במאמר הזה מוסבר איך ליצור רכב מסביבת שרת באמצעות gRPC או REST. אתם יכולים ליצור רכב מ-Driver SDK, בתנאי שהקציתם לאפליקציה סביבה מהימנה באמצעות פרטי הכניסה המתאימים.
כדי להבין איך משתמשים ב-Driver SDK ליצירת כלי רכב, אפשר לעיין במאמרים הבאים:
- Driver SDK למשימות מתוזמנות
- תפקידים בחשבון השירות בקטע מידע בסיסי על Fleet Engine.
כדי ליצור רכב חדש מסביבת שרת, שולחים בקשת CreateDeliveryVehicle ל-Fleet Engine. משתמשים באובייקט CreateDeliveryVehicleRequest כדי להגדיר את המאפיינים של רכב המשלוחים החדש.
שדות של משימות מתוזמנות שקשורות לרכבים
כשיוצרים DeliveryVehicle, מגדירים את השדות האופציונליים הבאים:
attributeslast_locationtype
כדי ליצור רכב בלי להגדיר שדות אפשרויות, אפשר להשאיר את השדה DeliveryVehicle לא מוגדר ב-CreateDeliveryVehicleRequest.
דוגמה ליצירת רכב
כדי ליצור רכב, אתם יכולים להשתמש ב-ספריית Java gRPC או ב-REST. ברשימה המלאה של השפות הנתמכות מפורטות ספריות הלקוח של שירותי המשימות המתוזמנות.
Java
static final String PROJECT_ID = "my-delivery-co-gcp-project";
static final String VEHICLE_ID = "vehicle-8241890"; // Avoid auto-incrementing IDs.
DeliveryServiceBlockingStub deliveryService =
DeliveryServiceGrpc.newBlockingStub(channel);
// Vehicle settings
String parent = "providers/" + PROJECT_ID;
DeliveryVehicle vehicle = DeliveryVehicle.newBuilder()
.addAttributes(DeliveryVehicleAttribute.newBuilder()
.setKey("route_number").setValue("1")) // Opaque to the Fleet Engine
.build();
// Vehicle request
CreateDeliveryVehicleRequest createVehicleRequest =
CreateDeliveryVehicleRequest.newBuilder() // No need for the header
.setParent(parent)
.setDeliveryVehicleId(VEHICLE_ID) // Vehicle ID assigned by the Provider
.setDeliveryVehicle(vehicle)
.build();
// Error handling
// If Fleet Engine does not have vehicle with that ID and the credentials of the
// requestor pass, the service creates the vehicle successfully.
try {
DeliveryVehicle createdVehicle =
deliveryService.createDeliveryVehicle(createVehicleRequest);
} catch (StatusRuntimeException e) {
Status s = e.getStatus();
switch (s.getCode()) {
case ALREADY_EXISTS:
break;
case PERMISSION_DENIED:
break;
}
return;
}
REST
כדי ליצור רכב מסביבת שרת, שולחים קריאת HTTP REST אל CreateDeliveryVehicle:
POST https://fleetengine.googleapis.com/v1/providers/<project_id>/deliveryVehicles?deliveryVehicleId=<id>
גוף ה-POST מייצג את הישות DeliveryVehicle שצריך ליצור. אפשר לציין את השדות האופציונליים הבאים:
attributeslastLocationtype
# Set $JWT, $PROJECT_ID, and $VEHICLE_ID in the local
# environment
curl -X POST "https://fleetengine.googleapis.com/v1/providers/${PROJECT_ID}/deliveryVehicles?deliveryVehicleId=${VEHICLE_ID}" \
-H "Content-type: application/json" \
-H "Authorization: Bearer ${JWT}" \
--data-binary @- << EOM
{
"attributes": [{"key": "model", "value": "sedan"}],
"lastLocation": {"location": {"latitude": 12.1, "longitude": 14.5}}
}
EOM
כדי ליצור רכב בלי להגדיר שדות, משאירים את גוף בקשת ה-POST ריק. הרכב החדש שנוצר מחלץ מזהה רכב מהפרמטר deliveryVehicleId בכתובת ה-URL של ה-POST.
דוגמה:
# Set $JWT, $PROJECT_ID, and $VEHICLE_ID in the local
# environment
curl -X POST "https://fleetengine.googleapis.com/v1/providers/${PROJECT_ID}/deliveryVehicles?deliveryVehicleId=${VEHICLE_ID}" \
-H "Content-type: application/json" \
-H "Authorization: Bearer ${JWT}"